.386                   ; minimum processor needed for 32 bit
.model flat, stdcall   ; FLAT memory model & STDCALL calling
option casemap :none   ; set code to case sensitive

include \masm32\include\windows.inc
include \masm32\include\masm32.inc

include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\masm32.lib

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data

    hWnd      dd 0
    hInstance dd 0
    lpCmdLine dd 0
    screen_w  dd 0
    screen_h  dd 0
    mouse_pt  dd 0

    idMelt    dd 0
    hQThread  dd 0
    bRunning  dd 0
    bStopping dd 0
    hDC       dd 0
    hdcCompat dd 0
    hdcScreen dd 0
    hbmScreen dd 0

    hWndListView dd 0 ; *****

    szDisplay db "DISPLAY",0
    ClassName db "MeltWindowClass",0
    AppName   db "Melt Display Hack",0

.code

Melt proc

    LOCAL w :DWORD, h :DWORD, x :DWORD, y :DWORD, x1 :DWORD, y1 :DWORD

    mov eax, screen_w           ; width
    sub eax, 3        
    invoke nrandom, eax
    add eax, 1
    mov w, eax

    mov eax, screen_h           ; height
    sub eax, 3
    invoke nrandom, eax
    add eax, 1
    mov h, eax

    mov eax, screen_w           ; top-left-x
    sub eax, 1
    sub eax, w
    invoke nrandom, eax
    add eax, 1
    mov x, eax

    mov eax, screen_h           ; top-left-y
    sub eax, 2
    sub eax, h
    invoke nrandom, eax
    add eax, 1
    mov y, eax

    mov eax, 3                  ; destination top-left-x
    invoke nrandom, eax
    sub eax, 1
    add eax, x
    mov x1, eax

    mov eax, 3                  ; destination top-left-y
    invoke nrandom, eax
    neg eax
    add eax, y
    mov y1, eax

    invoke BitBlt,hdcScreen,x,y,w,h,hdcScreen,x1,y1,SRCCOPY      

    ret

Melt endp

;

szProgman        db "Progman",0
szDefView        db "SHELLDLL_DefView",0
szListView       db "SysListView32",0

GetDesktopHandle PROC
  invoke  GetDesktopWindow
  test    eax, eax
  jz      @F
  invoke  FindWindowEx, eax, 0, ADDR szProgman, 0
  test    eax, eax
  jz      @F
  invoke  FindWindowEx, eax, 0, ADDR szDefView, 0
@@:
  ret
GetDesktopHandle ENDP

GetListViewHandle PROC
  invoke  GetDesktopHandle
  test    eax, eax
  jz      @F
  invoke  FindWindowEx, eax, 0, ADDR szListView, 0
@@:
  ret
GetListViewHandle ENDP

;

MeltThread:
    invoke GetListViewHandle
    mov    hWndListView, eax
    invoke GetDesktopHandle

    invoke GetDC, eax;0
    mov    hDC, eax
    ;invoke CreateDC,ADDR szDisplay, NULL, NULL, NULL
    mov    hdcScreen, eax
    invoke CreateCompatibleDC, hdcScreen
    mov    hdcCompat, eax
    invoke CreateCompatibleBitmap, hdcScreen, screen_w,screen_h
    mov    hbmScreen, eax
    invoke SelectObject, hdcCompat, hbmScreen

    invoke SetThreadPriority,idMelt,THREAD_PRIORITY_IDLE

    invoke Sleep, 100

    mov    bRunning, 1

@@:
    call   Melt
    invoke InvalidateRect, hWndListView, 0, 0 ; allow icons to be redrawn
    invoke Sleep, 10
    mov    eax,bStopping
    test   eax, eax
    jz     @B

    invoke DeleteObject, hdcCompat
    invoke DeleteObject, hbmScreen
    ;invoke DeleteDC, hdcScreen
    invoke InvalidateRect, 0, 0, FALSE
    invoke UpdateWindow, 0
    invoke ReleaseDC, 0, hDC

    mov    bRunning, 0

    invoke ExitThread, 0


WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc PROTO :DWORD, :DWORD, :DWORD, :DWORD

; 
start:
; 

    invoke GetModuleHandle,NULL
    mov    hInstance,eax
    invoke GetSystemMetrics, SM_CXSCREEN
    mov    screen_w, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    mov    screen_h, eax
    invoke GetCommandLine
    mov    lpCmdLine, eax

    invoke CreateThread,0,4096,ADDR MeltThread,0,0,ADDR idMelt
    mov    hQThread,eax

    invoke WinMain,hInstance,NULL,lpCmdLine,SW_SHOWNORMAL

    invoke ExitProcess, 0

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL  wc:WNDCLASSEX
    LOCAL  msg:MSG

    mov    wc.cbSize,sizeof WNDCLASSEX
    mov    wc.style,CS_HREDRAW or CS_VREDRAW
    mov    wc.lpfnWndProc,offset WndProc
    mov    wc.cbClsExtra,NULL
    mov    wc.cbWndExtra,NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground,NULL
    mov    wc.lpszMenuName,NULL
    mov    wc.lpszClassName,offset ClassName
    mov    wc.hIcon,NULL
    mov    wc.hIconSm,NULL
    invoke LoadCursor,NULL,IDC_ARROW
    mov    wc.hCursor,eax
    invoke RegisterClassEx,addr wc
    invoke CreateWindowEx,WS_EX_TRANSPARENT or WS_EX_TOPMOST, \
                          ADDR ClassName, ADDR AppName, \
                          WS_POPUP, CW_USEDEFAULT,\
                          CW_USEDEFAULT, screen_w, screen_h, NULL, NULL, \
                          hInstance,NULL
    mov    hWnd, eax

    invoke ShowWindow,hWnd,SW_MINIMIZE;CmdShow
    invoke UpdateWindow,hWnd

    .while TRUE
        invoke GetMessage,addr msg,NULL,0,0
        .BREAK .if !eax
            invoke TranslateMessage,addr msg
            invoke DispatchMessage,addr msg
    .endw

    mov    eax,msg.wParam
    ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    .if uMsg==WM_MOUSEMOVE
        mov    eax, bRunning            ; ignore until MeltThread starts
        test   eax, eax
        jz     @F
        mov    eax, lParam              ; ignore duplicate mouse moves
        xchg   eax, mouse_pt
        cmp    eax, mouse_pt
        je     @F
        test   eax, eax                 ; and ignore the first
        jz     @F
        mov    bStopping, 1             ; otherwise, stop the show!
        invoke SendMessage,hWin,WM_CLOSE,0,0
     @@:

    .elseif uMsg==WM_KEYDOWN || uMsg==WM_RBUTTONDOWN || uMsg==WM_LBUTTONDOWN
        mov    bStopping, 1
        invoke SendMessage,hWin,WM_CLOSE,0,0

    .elseif uMsg==WM_CLOSE
        mov    bStopping, 1
        invoke SetThreadPriority,idMelt,THREAD_PRIORITY_HIGHEST
        invoke DestroyWindow,hWin

    .elseif uMsg==WM_DESTROY
        .while bRunning==1
            invoke Sleep,10
        .endw
        mov    bStopping, 0
        invoke PostQuitMessage,NULL

    .else
        invoke DefWindowProc,hWin,uMsg,wParam,lParam
        ret
    .endif

    xor    eax,eax
    ret

WndProc endp

end start
